#include "include/GL/freeglut.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "hwFunctions.h"
#include "MnistReader.h"

#define width 900
#define height 768


static unsigned int m_z=12345,m_w=45678;

#define robotX 50
#define robotY 50
#define MAXDIST 500
#define laserAngleMin = 30
#define laserAngleMax = (180-30)

#define TIME 2000

char gridWorld[][90]={
    "                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         "
};

char maze[][90]={
	"#########################################################################################",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"##     ###########                          #                                           #",
	"#      #         #                          #                                           #",
	"#      #         #                          #                                           #",
	"#      ###########                          #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#########################################################################################"
};

bool isBumped(int x, int y){

	int xx,yy;
	for (double t=0; t<10; t+=0.01){
		xx = (x+(int)(22*sin(t)))/10;
		yy = (y+(int)(22*cos(t)))/10;
		if (maze[yy][xx]!=' '){
			return true;
		}
	}
	return false;
}

int main(int argc, char** argv)
{
	int tracex[TIME];
	int tracey[TIME];
	double deltaANGLE = 10;
	int scanAngle = 90;

	int turnMem=0;
	double laserMin = 30;
	double laserMax = 180-30;
	initWindow(argc,argv,width,height,"Magic Robot Sim");

	double scanArray[1000];
	double scanArrayOld[1000];

	int xRob = robotY, yRob = robotX;
	int xRobOld, yRobOld;

	double robotVel=5;
	double robotAngleVel=0;

	double robotAngle = 90;

	int maxRays=0;


	// first layer

    for (int simStep=0;simStep<TIME;simStep++){

		// --- drawMaze
		for (int y=0;y<60;y++){
			for (int x=0;x<90;x++){
				setColor(0,0,0);
				drawBox(x*10,y*10,x*10+10,y*10+10);
				if (maze[y][x]==' '){
					setColor(0,0,0);
				}else{
					setColor(0,0,1);
				}
				drawBox(x*10,y*10,x*10+8,y*10+8);

				// ---- generated maze ---------

				if (gridWorld[y][x]==' '){
					setColor(0,0,0);
				}else{
					setColor(0,1,1);
				}
				drawBox(x*2,600+y*2,x*2+1,600+y*2+1);



			}
		}
		tracex[simStep] = xRob;
		tracey[simStep] = yRob;
		setColor(0.5,0.5,0.5);
		for (int t=0;t<simStep;t++){
			drawLine(tracex[t],tracey[t],tracex[t+1],tracey[t+1]);
		}
		setColor(1,1,1);
		// ----- This is the Robots program

		// xRob,yRob are from GPS sensor
		// robotAngle is from compass sensor

		for ( int t=0;t<maxRays;t++){

			double angle = (robotAngle-60) + t*deltaANGLE;

			int xx = (xRob+(int)(scanArray[t]*sin(angle/180.0*3.1415)))/10;
			int yy = (yRob+(int)(scanArray[t]*cos(angle/180.0*3.1415)))/10;
			if (scanArray[t]<MAXDIST-0.5){
				gridWorld[yy%60][xx%90] = '*';
			}

		}


		if (turnMem == 0){
			robotAngleVel = 0;

			if (scanArray[maxRays/5]<40){
				robotAngleVel = 5;			// turn right
				turnMem=25;
			}
			if (scanArray[maxRays-maxRays/5]<40){
				robotAngleVel = -5;			// turn left
				turnMem=25;
			}

		}
		else{
			turnMem--;
		}

		// ----------------------------------------------------

		robotAngle += robotAngleVel;

		xRob = xRob + robotVel*sin(robotAngle/180.0*3.1415);
		yRob = yRob + robotVel*cos(robotAngle/180.0*3.1415);

		laserMin = robotAngle - 60;
		laserMax = robotAngle + 60;

		if (isBumped(xRob, yRob)){
			xRob = xRobOld;
			yRob = yRobOld;
		}
		else{
			xRobOld = xRob;
			yRobOld = yRob;
		}


		// --- draw Robot
		drawCircle(xRob,yRob,20);
		setColor(1,0,0);
		maxRays=0;
		for (double angle = laserMin; angle<laserMax; angle+=deltaANGLE){
			for (double dist=20;dist<MAXDIST;dist+=0.5){
					setPixel(xRob+(int)(dist*sin(angle/180.0*3.1415)), yRob+(int)(dist*cos(angle/180.0*3.1415)));
					int xx = (xRob+(int)(dist*sin(angle/180.0*3.1415)))/10;
					int yy = (yRob+(int)(dist*cos(angle/180.0*3.1415)))/10;

					scanArray[maxRays%1000] = dist; // measure Laserscan Data

					if (maze[yy][xx]!=' '){
						break;
					}
			}
			maxRays++;
		}








		display();
		glutMainLoopEvent();
	}


}


		// --- Lasermatching ---
/*
		double distance;
		double minDist;
		double minShift;
		double angle[1000];
		double xMean=0;
		double yMean=0;
		double xx=0;
		double yy=0;

		double DIST=0,ANGLE=0;


		double scanOldx[100];
		double scanOldy[100];
		double scanX[100];
		double scanY[100];


		if (simStep>0){
			DIST=0;
			double meanCounter=0;
			// 1. step: compute minimal distances and angles of all



			double bestDist = 1000;
			double rotation = 0;
			double transX = 0;
			double transY = 0;
			for (double alpha = -5; alpha<5; alpha+=1){
				for (double distX = -8; distX<8;distX+=1){
					for (double distY = -8; distY<8;distY+=1){

						// reset old position
						for (int t=0;t<maxRays;t++){
							 scanOldx[t] = scanArrayOld[t]*sin((t*10.0)/180.0*3.1415+alpha/180.0*3.1415);
							 scanOldy[t] = scanArrayOld[t]*cos((t*10.0)/180.0*3.1415+alpha/180.0*3.1415);
							 scanX[t]    = scanArray[t]*sin((t*10.0)/180.0*3.1415);
							 scanY[t]    = scanArray[t]*cos((t*10.0)/180.0*3.1415);


							setColor(1,0,0);
							drawLine(100,100,100+scanX[t],100-scanY[t]);
							setColor(0,1,0);
							drawLine(100,100,100+scanOldx[t],100-scanOldy[t]);
						}
						// turn & shift
						for (int t=0;t<maxRays;t++){
							//double xe = scanOldx[t]*cos(alpha/180.0*3.1415) + scanOldy[t]*sin(alpha/180.0*3.1415);
							//double ye = -scanOldx[t]*sin(alpha/180.0*3.1415) + scanOldy[t]*cos(alpha/180.0*3.1415);
							scanOldx[t] += distX;
							scanOldy[t] += distY;

							//scanOldx[t] += distX;
							//scanOldy[t] += distY;
						}


						DIST = 0;
						for (int shift = -3; shift<3; shift++){
							minDist = 1000;
							distance = 0;
							double meanCNT=0;
							for (int t=3;t<maxRays-3;t++){
								if (scanArrayOld[t]<MAXDIST && scanArray[shift]<MAXDIST){
									distance += sqrt((scanOldx[t] - scanX[t+shift])*(scanOldx[t] - scanX[t+shift])+
										            (scanOldy[t] - scanY[t+shift])*(scanOldy[t] - scanY[t+shift]));
									meanCNT++;
								}
							}


							distance/=meanCNT;
							if (distance< minDist){
								minDist = distance;
								minShift = shift;
							}
						}
						// DIST ist to be minimized!

						if (minDist<bestDist){
							transX = -distX;
							transY = -distY;
							rotation = alpha;
							bestDist = DIST;
						}
					}
				}
			}


			char text[1000];
			sprintf(text,"transx=%d transy=%d     ",(int)transX,(int)transY);
			glPrint(600,50,text);

			xxx[simStep] = xxx[simStep-1] + transX;
			yyy[simStep] = yyy[simStep-1] + transY;

			text[1000];
			sprintf(text,"Koord:%d,%d     ",xxx[simStep],yyy[simStep]);
			glPrint(600,80,text);
		}
//		xxx[simStep] = xRob;
//		yyy[simStep] = yRob;

		setColor(1,1,1);
		for (int t=1; t<simStep;t++){
			drawLine(xxx[t-1],yyy[t-1],xxx[t],yyy[t]);
		}


		for (int t=0 ; t<maxRays; t++){
			scanArrayOld[t] = scanArray[t];
		}

*/
